#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

vector<vector<pair<int,int>>> graph;
vector<vector<int>> dp;
int n, k;

vector<int> full, haveone;

void dfs(int v){

    vector<int> prec;

    if(graph[v].empty())return;

    for(auto [to, w] : graph[v]){
        dfs(to);
        prec.pb(to);
    }

    sort(all(prec), [&](int a, int b){
       return haveone[a] - full[a] > haveone[b] - full[b];
    });

    for(int i = 0;i<graph[v].size();i++){
        if(i < k){
            full[v] += haveone[prec[i]] + 1;
        }else{
            full[v] += full[prec[i]];
        }

        if(i < k - 1){
            haveone[v] += max(haveone[prec[i]] + 1, full[prec[i]]);
        }else{
            haveone[v] += full[prec[i]];
        }
    }
}


void solve() {
    cin>>n>>k;
    graph.resize(n);
    dp.resize(n, vector<int> (k));
    full.resize(n);
    haveone.resize(n);
    for(int i = 0;i<n-1;i++){
        int p,w;
        cin>>p>>w;
        graph[p-1].eb(i+1,w);
    }

    dfs(0);

    cout<<max(haveone[0], full[0])<<' '<<0<<'\n';
}

signed main() {
//    ioss
    int t = 1;
//    cin >> t;
    while (t-- > 0) {
        solve();
    }
    return 0;
}

/*
 *
8 2
1 0
1 0
1 0
2 0
2 0
2 0
1 0
 */
/*
 4 8
 3 4 1 2
 2 3 4 5
 1 16 2 4 5 6 10 15

 */