#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

#define int long long

vector<vector<pair<int,int>>> graph;
vector<map<int,int>> mp;
vector<vector<int>> dp;
int n, k;

vector<int> full, haveone;
vector<int> fullc, haveonec;

void dfs(int v){
    if(graph[v].empty())return;

    vector<int> prec;

    for(auto [to, w] : graph[v]){
        dfs(to);
        prec.pb(to);
    }

    sort(all(prec), [&](int a, int b){
        if(haveone[a] - full[a] == haveone[b] - full[b])
            return mp[v][a] < mp[v][b];
       return haveone[a] - full[a] > haveone[b] - full[b];
    });

    for(int i = 0, cnt = 0;i<graph[v].size();i++){
        if(i < k){
            full[v] += haveone[prec[i]] + 1;
            fullc[v] += haveonec[prec[i]] + mp[v][prec[i]];
        }else{
            full[v] += full[prec[i]];
            fullc[v] += fullc[prec[i]];
        }

        if(cnt < k - 1){
            if(full[prec[i]] == haveone[prec[i]] + 1){
                haveone[v] += haveone[prec[i]] + 1;
                if(haveonec[prec[i]] + mp[v][prec[i]] < fullc[prec[i]]){
                    cnt++;
                }
                haveonec[v] += min(haveonec[prec[i]] + mp[v][prec[i]], fullc[prec[i]]);
            }else if(haveone[prec[i]] + 1 > full[prec[i]]){
                haveone[v] += haveone[prec[i]] + 1;
                haveonec[v] += haveonec[prec[i]] + mp[v][prec[i]];
                cnt++;
            }else{
                haveone[v] += full[prec[i]];
                haveonec[v] += fullc[prec[i]];
            }
        }else{
            haveone[v] += full[prec[i]];
            haveonec[v] += fullc[prec[i]];
        }
    }
}


void solve() {
    cin>>n>>k;
    graph.resize(n);
    mp.resize(n);
    dp.resize(n, vector<int> (k));
    full.resize(n);
    haveone.resize(n);
    fullc.resize(n);
    haveonec.resize(n);
    for(int i = 0;i<n-1;i++){
        int p,w;
        cin>>p>>w;
        mp[p-1][i+1] = w;
        graph[p-1].eb(i+1,w);
    }

    dfs(0);

    if(full[0] == haveone[0]){
        cout<<full[0]<<' '<<min(fullc[0], haveonec[0])<<'\n';
    }else if(full[0] > haveone[0]){
        cout<<full[0]<<' '<<fullc[0]<<'\n';
    }else{
        cout<<haveone[0]<<' '<<haveonec[0]<<'\n';
    }
}

signed main() {
//    ioss
    int t = 1;
//    cin >> t;
    while (t-- > 0) {
        solve();
    }
    return 0;
}

/*
 *
8 2
1 0
1 0
1 0
2 0
2 0
2 0
1 0


 8 3
1 5
1 2
1 4
2 6
2 7
2 2
1 6
 */
/*
 4 8
 3 4 1 2
 2 3 4 5
 1 16 2 4 5 6 10 15

 */