#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

struct Fenvick{
    vector<ll> t;
    int n;

    Fenvick(int mx){
        n = mx;
        t.resize(n+1);
    }

    ll sum_(int k){
        ll res = 0;
        for(; k > 0; k -= k & -k){
            res += t[k];
        }
        return res;
    }

    ll sum(int L, int R){
        return sum_(R) - sum_(L - 1);
    }

    void add(int k, ll x){
        for(;k<n; k += k & -k){
            t[k] += x;
        }
    }

    void update(int k, ll x){
        add(k, x - sum(k,k));
    }

};

void solve(){
    int n;
    cin>>n;
    vector<ll> arr(n);
    for(auto &i : arr)cin>>i;
    ll sum = 0;
    for(auto i : arr)sum += i;

    int q, del = 0;
    cin>>q;
    while(q-->0){
        int type;
        cin>>type;
        if(type == 1) {
            ll k, x;
            cin >> k >> x;
            k--;
            sum += x - arr[(k + del) % n];
            arr[(k + del) % n] = x;
            cout << sum << endl;
        }else if(type == 2){
            int k;
            cin>>k;
            del += n - k;
            cout<<sum<<endl;
        }

    }
}

signed main() {
//    ioss
    int t = 1;
//    cin>>t;
    while(t-->0){
        solve();
    }
    return 0;
}
