#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

struct Fenvick{
    vector<ll> t;
    int n;

    Fenvick(int mx){
        n = mx;
        t.resize(n+1);
    }

    ll sum_(int k){
        ll res = 0;
        for(; k > 0; k -= k & -k){
            res += t[k];
        }
        return res;
    }

    ll sum(int L, int R){
        return sum_(R) - sum_(L - 1);
    }

    void add(int k, ll x){
        for(;k<n; k += k & -k){
            t[k] += x;
        }
    }

    void update(int k, ll x){
        add(k, x - sum(k,k));
    }

};

const ll mod = 1e9;

void solve(){
    int n,f;
    cin>>n>>f;
    vector<ll> d(n);

    if(f == 1){
        for(auto &i : d)cin>>i;

    }else if(f == 2){
        ll m, x,y,z;
        cin>>m>>x>>y>>z;
        vector<ll> c(m);
        for(auto &i : c)cin>>i;

        for(int i = 0;i<n;i++){
            if(i < m)d[i] = c[i];
            else d[i] = ((x * d[i-2] + y * d[i-1] + z) % mod) + 1;
        }
    }

    int mxId = 0;
    for(int i = 0;i<n;i++){
        if(d[i] > d[mxId])mxId = i;
    }

    auto ans = [&](int m){
        ll need = 0, st = (mxId - m + n) % n;
        for(int i = 0;i<n;i++){
            need = max(need, d[(st + i) % n] - i);
        }
        return need;
    };

    int l = 0, r = n + 1;
    while(r - l > 2){
        int m1 = l + (r - l) / 3;
        int m2 = l + (r - l) * 2 / 3;
        if(ans(m1) < ans(m2)){
            r = m2;
        }else{
            l = m1;
        }
    }
    ll ansA = inf, ansB = -1;



    for(int m = max(0,l - 5); m < min(n, r + 5); m++){
//    for(int m = 0; m<n;m++){
        ll t = ans(m);
        if(t < ansA) ansA = t, ansB =  (mxId - m + n) % n + 1;
    }
    cout<<ansA<<' '<<ansB<<'\n';
}

signed main() {
    ioss
    int t = 1;
//    cin>>t;
    while(t-->0){
        solve();
    }
    return 0;
}

/*
10
2
5 1 2 3
1 2 3 4 5
 */