#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

struct Fenvick{
    vector<ll> t;
    int n;

    Fenvick(int mx){
        n = mx;
        t.resize(n+1);
    }

    ll sum_(int k){
        ll res = 0;
        for(; k > 0; k -= k & -k){
            res += t[k];
        }
        return res;
    }

    ll sum(int L, int R){
        return sum_(R) - sum_(L - 1);
    }

    void add(int k, ll x){
        for(;k<n; k += k & -k){
            t[k] += x;
        }
    }

    void update(int k, ll x){
        add(k, x - sum(k,k));
    }

};

const ll mod = 1e9;

void solve(){
    int n,f;
    cin>>n>>f;
    vector<ll> d(n);

    if(f == 1){
        for(auto &i : d)cin>>i;

    }else if(f == 2){
        ll m, x,y,z;
        cin>>m>>x>>y>>z;
        vector<ll> c(m);
        for(auto &i : c)cin>>i;

        for(int i = 0;i<n;i++){
            if(i < m)d[i] = c[i];
            else d[i] = ((x * d[i-2] + y * d[i-1] + z) % mod) + 1;
        }
    }

    vector<ll> pref(n);
    pref[n-1] = d[n-1] - (n-1);
    for(int i = n-2;i>=0;i--){
        pref[i] = max(pref[i+1], d[i] - i);
    }

    ll ansA = pref[0], ansB = 1, leftAns = -inf;

    for(int i = 0;i<n;i++){
        if(i != 0){
            leftAns = max(leftAns, d[i-1] - n);
        }
        if(ansA > max(leftAns, pref[i]) + i){
            ansA =  max(leftAns, pref[i]) + i;
            ansB = i + 1;
        }
    }
    cout<< ansA<<' '<<ansB<<'\n';

//    multiset<ll> st;
//    for(int i = 0;i<n;i++){
//        st.insert(d[i] - i);
//    }
//    ll ansA = *st.rbegin(), ansB = 1;
//
//    for(int i = 0;i<n-1;i++){
//        st.erase(st.find(d[i] - i));
//        st.insert(d[i] - n - i);
//        if(ansA > *st.rbegin() + i + 1){
//            ansA = *st.rbegin() + i + 1, ansB = i + 1 + 1;
//        }
//    }
//    cout << ansA << ' ' << ansB <<'\n';

//    for(int i = n-1;i>=0;i--) {
    //        for(int j = 0;j < n; j++){
    //            cout<<d[j] - ((i + j + n) % n) - (n - i)<<' ';
    //        }
    //        cout<<endl;
    //    }
}




signed main() {
    ioss
    int t = 1;
//    cin>>t;
    while(t-->0){
        solve();
    }
    return 0;
}

/*
10
2
5 1 2 3
1 2 3 4 5

5
1
3 7 2 4 5


3 7 2 4 5

3 6 0 1 1
-1 7 1 2 2
0 3 2 3 3
1 4 -2 4 4



  3 6 0 1 1
 -2 6 0 1 1   +1
 -2 1 0 1 1   +2
 -2 1 -5 1 1  +3
 -2 1 -5 -4 1 +4

 */