#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

struct tr{

    ld x[3], y[3];
    ld len[3];

    tr(){
        for(int i = 0;i<3;i++)cin>>x[i]>>y[i];
        len[0] = (x[0] - x[1]) * (x[0] - x[1]) + (y[0] - y[1]) * (y[0] - y[1]);
        len[1] = (x[1] - x[2]) * (x[1] - x[2]) + (y[1] - y[2]) * (y[1] - y[2]);
        len[2] = (x[2] - x[0]) * (x[2] - x[0]) + (y[2] - y[0]) * (y[2] - y[0]);
    }

};

const ld EPS = 1e-5;

void solve() {
    int t;
    cin>>t;

    int n;
    cin>>n;
    vector<tr> arr(n);


    auto ok = [&](int a, int b, int c, int d){

        for(int apos = 0; apos < 3; apos++){
            for(int bpos = 0; bpos < 3; bpos++){
                for(int cpos = 0; cpos < 3; cpos++){
                    int ok = arr[a].len[apos] == arr[d].len[0] && arr[b].len[bpos] == arr[d].len[1] && arr[c].len[cpos] == arr[d].len[2];

                    // проверить что углы равны (по маленьким треугольникам и по большим)

                    ld prLens[3] = {sqrt(arr[a].len[(apos + 1) % 3]) + sqrt(arr[c].len[(cpos + 2) % 3]), sqrt(arr[a].len[(apos + 2) % 3]) + sqrt(arr[b].len[(bpos + 1) % 3]), sqrt(arr[b].len[(bpos + 2) % 3]) + sqrt(arr[c].len[(cpos + 1) % 3])};

                    // 1 * 1 = 2 * 2 + 3 * 3 - 2 * 2 * 3 * cosx
                    // (1^2 - 2^2 - 3^2) / (-2 * 2 * 3) = cosx

                    auto getCos = [&](ld la, ld lb, ld lc){
                        // la = lb + lc - 2 * sqrt(lb) * sqrt(lc) * cosx
                        return (la - lb - lc) / (-2 * sqrt(lb) * sqrt(lc));
                    };

                    ld cos1Small = getCos(arr[a].len[apos], arr[a].len[(apos + 1) % 3], arr[a].len[(apos + 2) % 3]);
                    ld cos1Big = getCos(prLens[2] * prLens[2], prLens[1] * prLens[1], prLens[0] * prLens[0]);

                    ok = ok && (abs(cos1Small - cos1Big) <= EPS);

                    ld cos2Small = getCos(arr[b].len[bpos], arr[b].len[(bpos + 1) % 3], arr[b].len[(bpos + 2) % 3]);
                    ld cos2Big = getCos(prLens[0] * prLens[0], prLens[1] * prLens[1], prLens[2] * prLens[2]);

                    ok = ok && (abs(cos2Small - cos2Big) <= EPS);

                    ld cos3Small = getCos(arr[c].len[cpos], arr[c].len[(cpos + 1) % 3], arr[c].len[(cpos + 2) % 3]);
                    ld cos3Big = getCos(prLens[1] * prLens[1], prLens[0] * prLens[0], prLens[2] * prLens[2]);

                    ok = ok && (abs(cos3Small - cos3Big) <= EPS);

                    if(ok)return 1;
                }
            }
        }


        return 0;
    };

    set<pair<pair<int,int>, pair<int,int>>> ans;

    for(int id4 = 0;id4<n;id4++){
        for(int id1 = 0; id1 < n;id1++) {
            if (id1 == id4)continue;
            for(int id2 = 0; id2 < n; id2++){
                if(id2 == id1 || id2 == id4)continue;
                for(int id3 = 0; id3 < n; id3++){
                    if(id3 == id1 || id3 == id2 || id3 == id4)continue;
                    int res = ok(id1, id2, id3, id4);


                    if(res){
                        vector<int> ms = {id1, id2, id3, id4};
                        sort(all(ms));
                        ans.insert({{ms[0], ms[1]},{ms[2], ms[3]}});
                    }
                }
            }
        }
    }


    cout<<ans.size()<<'\n';

    for(auto i : ans){
        cout<<i.first.first + 1<<' '<<i.first.second + 1<<' '<<i.second.first + 1<<' '<<i.second.second + 1<<'\n';
    }
    cout<<'\n';

}
signed main() {
    ioss
    int t = 1;
//    cin>>t;
    while(t-->0){
        solve();
    }
    return 0;
}
