#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

mt19937 rnd(time(0));
#define ioss ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pb push_back
#define eb emplace_back

const int inf = 1e9 + 10;

ll gcd(ll a,ll b){
    if(a == 0)return b;
    return gcd(b%a, a);
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<int> a(n), b(n);
    for (auto &i: a)cin >> i;
    for (auto &i: b)cin >> i;
    sort(all(a));
    sort(rall(b));

    vector<pair<int, int>> questinons(q);
    vector<pair<int, int>> ans(q);
    for (int i = 0; i < q; i++) {
        cin >> questinons[i].first;
        questinons[i].second = i;
    }
    sort(all(questinons));
    // считаю ответ

    int idq = 0, now = 1;

    auto make = [&](int x, int y){
        int gc = gcd(x,y);
        x/=gc;
        y/=gc;
        return 1.0 * x / y;
    };

    set<pair<ld, pair<int,int>>> st;
    for(int i = 0; i<n;i++){
        st.insert({make(a[0], b[i]),{0,i}});
    }

    while(now <= questinons[q-1].first){
        auto v = *st.begin();
//        cout<<now<<' '<<a[v.second.first]<<' '<<b[v.second.second]<<'\n';
        st.erase(v);
        int a_id = v.second.first;
        int b_id = v.second.second;
        if(now == questinons[idq].first){
            ans[questinons[idq].second] = {a[a_id], b[b_id]};
            idq++;
        }

        long double nxt = 1e9;
        if(!st.empty()){
            nxt = (*st.begin()).first;
        }

        int l = a_id, r = n;
        while(r - l > 1){
            int m = (r + l) / 2;
//            cout<<l<<' '<<r<<' '<<nxt<<'\n';
            if(a_id + m < questinons[idq].first && make(a[m], b[b_id]) <= nxt){
                l = m;
            }else{
                r = m;
            }
        }
        now += l - a_id;
        if(l != a_id){
            a_id = l;
            st.insert({make(a[a_id], b[b_id]), {a_id, b_id}});
        }else{
            if(l + 1 < n){
                a_id = l + 1;
                st.insert({make(a[a_id], b[b_id]), {a_id, b_id}});
            }
            now++;
        }



//        if(a_id + 1 < n){
//            a_id++;
//            st.insert({make(a[a_id], b[b_id]), {a_id, b_id}});
//        }
//        now++;
    }


    for (auto[e, f]: ans) {
        int gc = gcd(e, f);
        cout << e / gc << ' ' << f / gc << '\n';
    }

}

signed main() {
//    ioss
    int t = 1;
//    cin >> t;
    while (t-- > 0) {
        solve();
    }
    return 0;
}
/*
 4 8
 3 4 1 2
 2 3 4 5
 1 16 2 4 5 6 10 15

 */